---
title: Programming in C
subtitle: Pointers
layout: layouts/presentation.njk
requires: structs, working with multiple files (for exercises)
---

<section>
  <h2>Purpose of Pointers</h2>

  <section>
  <h3>Which Problems do Pointers Solve?</h3>
  <ul>
    <li>Pass arrays to functions</li>
    <li>Increases performance when passing large data structures to functions</li>
    <li>Using pointers improves performance for repetitive operations (eg. iteration)</li>
    <li>Function pointers</li>
    <li>Change parameter values from a function</li>
    <li class="fragment">Prerequisite for using memory from the heap (free store)</li>
    <li class="fragment">Necessary for implementing high level data structures (linked lists, trees, ...)</li>
  </ul>
  </section>

  <section>
  <h3>Which Problems do Pointers Cause?</h3>
  <ul>
    <li>Prone to bugs</li>
    <li>Syntax can be hard to read and understand</li>
    <li>Modifying parameters breaks functional programming paradigm (<code>const Type*</code>)</li>
  </ul>

  <div class="fragment">
    Many of these problems are solved by C++ and higher level languages
  </div>
  </section>
</section>

<section>
  <h2>Definition</h2>
  <ul>
    <li>A <strong>pointer stores the memory address of a variable</strong></li>
    <li>Pointers can point to other pointers</li>
    <li>Obtaining the value stored at a pointer's address: <code>*</code> (de-reference operator)</li>
    <li>Getting the address of a variable: <code>&</code>
      (address-of operator)</li>
    <li><a href="https://en.wikipedia.org/wiki/Pointer_(computer_programming)#C_pointers">C pointers</a></li>
  </ul>
</section>

<section>
  <h2>Working with Pointers</h2>
  <section>
    <h3>Declaration</h3>
{% highlight "c" %}
Type* ptr;
{% endhighlight %}

<div class="fragment">
    <p>Pointers should be initialized as <code>NULL</code> pointers</p>
{% highlight "c" %}
Type* ptr = NULL;
{% endhighlight %}
</div>
  </section>

  <section>
    <h3>Changing a Variable Through a Pointer</h3>
{% highlight "c 1,2" %}
int a = 5;
int* a_ptr = &a;
*a_ptr += 5;
{% endhighlight %}
<div class="fragment">
  <p>Complete Program</p>

{% highlight "c 4,5" %}
{% include "source/c/pointers/basics.c" %}
{% endhighlight %}
{% include_code "source/c/pointers/basics.c" %}
</div>
  </section>

  <section>
    <h3>Pointer to a Pointer</h3>
{% highlight "c 6-9" %}
{% include "source/c/pointers/pointer_to_pointer.c" %}
{% endhighlight %}
{% include_code "source/c/pointers/pointer_to_pointer.c" %}
  </section>
</section>

  <section>
  <h2>Examples</h2>

  <section>
    <h3>Update Function Parameters</h3>
    <p><strong>Avoid changing parameters whenever possible!</strong></p>
{% highlight "c 3-4,11,12" %}
{% include "source/c/pointers/update_parameters.c" %}
{% endhighlight %}
{% include_code "source/c/pointers/update_parameters.c" %}
  </section>

  <section>
    <h3>Iterate Over an Array</h3>
{% highlight "c 5" %}
{% include "source/c/pointers/array.c" %}
{% endhighlight %}
{% include_code "source/c/pointers/array.c" %}
  </section>

  <section>
    <h3>Pointer to Struct</h3>
    <p>The arrow operator <code>-></code> allows direct access to members
      when using pointers.</p>
{% highlight "c 3-4" %}
{% include "source/c/pointers/struct.c" %}
{% endhighlight %}
{% include_code "source/c/pointers/struct.c" %}
  </section>

  <section>
    <h3>String Operations</h3>
{% highlight "c 4-6" %}
{% include "source/c/pointers/string.c" %}
{% endhighlight %}
{% include_code "source/c/pointers/string.c" %}
  </section>

</section>

{% include 'slides/closing.njk' %}
